/* $Id: sys.c,v 1.1 1996/10/05 05:20:15 phil Exp $ */

/* support for HOST() on systems with POSIX.1 uname(2) */

#include <sys/utsname.h>

void
hwname(cp)
    char *cp;
{
#ifdef HWNAME
    strcpy(cp, HWNAME);
#else
    struct utsname u;

    if (uname(&u) < 0)
	strcpy(cp, "unknown");
    else
	strcpy(cp, u.machine);
#endif
}

void
osname(cp)
    char *cp;
{
#ifdef OSNAME
    strcpy(cp, OSNAME);
#else
    struct utsname u;

    if (uname(&u) < 0)
	strcpy(cp, "unknown");
    else
	sprintf(cp, "%s %s", u.sysname, u.release);
#endif
}
