/* $Id: getstring.c,v 1.3 1997/06/23 02:04:39 phil Exp $ */

#include "h.h"
#include "equ.h"			/* BCDFLD, etc */
#include "snotypes.h"			/* DESCR, etc */
#include "macros.h"			/* D_A() etc */

void
getstring( vp, dp, len )
    void *vp;				/* pointer to "natural variable" */
    char *dp;
    int len;
{
    int dlen;
    char *sp;

    if (!vp) {				/* null string? */
	*dp = '\0';
	return;
    }
    dlen = D_V(vp);			/* get length from title */
    sp = (char *) vp + BCDFLD;		/* get pointer to string */

    if (dlen > len-1)
	dlen = len-1;

    bcopy( sp, dp, dlen );
    dp[dlen] = '\0';
}

